/// @cond EO_CXX_EO_IMPL

inline Elm_Actionslider_Pos elm::actionslider::indicator_pos_get() const
{
   Elm_Actionslider_Pos _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_actionslider_indicator_pos_get());
   return _tmp_ret;
}

inline void elm::actionslider::indicator_pos_set(Elm_Actionslider_Pos pos_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_actionslider_indicator_pos_set(pos_));
}

inline Elm_Actionslider_Pos elm::actionslider::magnet_pos_get() const
{
   Elm_Actionslider_Pos _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_actionslider_magnet_pos_get());
   return _tmp_ret;
}

inline void elm::actionslider::magnet_pos_set(Elm_Actionslider_Pos pos_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_actionslider_magnet_pos_set(pos_));
}

inline Elm_Actionslider_Pos elm::actionslider::enabled_pos_get() const
{
   Elm_Actionslider_Pos _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_actionslider_enabled_pos_get());
   return _tmp_ret;
}

inline void elm::actionslider::enabled_pos_set(Elm_Actionslider_Pos pos_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_actionslider_enabled_pos_set(pos_));
}

inline ::efl::eina::string_view elm::actionslider::selected_label_get() const
{
   const char * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_actionslider_selected_label_get());
   return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
}

inline Elm_Actionslider_Pos eo_cxx::elm::actionslider::indicator_pos_get() const
{
   Elm_Actionslider_Pos _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_actionslider_indicator_pos_get());
   return _tmp_ret;
}

inline void eo_cxx::elm::actionslider::indicator_pos_set(Elm_Actionslider_Pos pos_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_actionslider_indicator_pos_set(pos_));
}

inline Elm_Actionslider_Pos eo_cxx::elm::actionslider::magnet_pos_get() const
{
   Elm_Actionslider_Pos _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_actionslider_magnet_pos_get());
   return _tmp_ret;
}

inline void eo_cxx::elm::actionslider::magnet_pos_set(Elm_Actionslider_Pos pos_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_actionslider_magnet_pos_set(pos_));
}

inline Elm_Actionslider_Pos eo_cxx::elm::actionslider::enabled_pos_get() const
{
   Elm_Actionslider_Pos _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_actionslider_enabled_pos_get());
   return _tmp_ret;
}

inline void eo_cxx::elm::actionslider::enabled_pos_set(Elm_Actionslider_Pos pos_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_actionslider_enabled_pos_set(pos_));
}

inline ::efl::eina::string_view eo_cxx::elm::actionslider::selected_label_get() const
{
   const char * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_actionslider_selected_label_get());
   return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::eo_cxx::elm::actionslider::operator ::elm::actionslider() const
{
   return *static_cast<::elm::actionslider const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::elm::actionslider::operator ::elm::actionslider&()
{
   return *static_cast<::elm::actionslider*>(static_cast<void*>(this));
}

inline ::eo_cxx::elm::actionslider::operator ::elm::actionslider const&() const
{
   return *static_cast<::elm::actionslider const*>(static_cast<void const*>(this));
}

template <typename T>
Elm_Actionslider_Pos elm_actionslider_indicator_pos_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->indicator_pos_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Actionslider_Pos _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void elm_actionslider_indicator_pos_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Actionslider_Pos pos_)
{
   try
      {
         static_cast<T*>(self->this_)->indicator_pos_set(pos_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
Elm_Actionslider_Pos elm_actionslider_magnet_pos_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->magnet_pos_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Actionslider_Pos _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void elm_actionslider_magnet_pos_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Actionslider_Pos pos_)
{
   try
      {
         static_cast<T*>(self->this_)->magnet_pos_set(pos_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
Elm_Actionslider_Pos elm_actionslider_enabled_pos_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->enabled_pos_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Actionslider_Pos _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void elm_actionslider_enabled_pos_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Actionslider_Pos pos_)
{
   try
      {
         static_cast<T*>(self->this_)->enabled_pos_set(pos_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
::efl::eina::string_view elm_actionslider_selected_label_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->selected_label_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         const char * _tmp_ret{};
         return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
      }
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm::actionslider >
{
   template <typename T>
   struct type
         : virtual operations< ::elm::layout >::template type<T>
         , virtual operations< ::evas::selectable_interface >::template type<T>
   {
      virtual Elm_Actionslider_Pos indicator_pos_get()
      {
         Elm_Actionslider_Pos _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_actionslider_indicator_pos_get());
            return _tmp_ret;
      }

      virtual void indicator_pos_set(Elm_Actionslider_Pos pos_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_actionslider_indicator_pos_set(pos_));
      }

      virtual Elm_Actionslider_Pos magnet_pos_get()
      {
         Elm_Actionslider_Pos _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_actionslider_magnet_pos_get());
            return _tmp_ret;
      }

      virtual void magnet_pos_set(Elm_Actionslider_Pos pos_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_actionslider_magnet_pos_set(pos_));
      }

      virtual Elm_Actionslider_Pos enabled_pos_get()
      {
         Elm_Actionslider_Pos _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_actionslider_enabled_pos_get());
            return _tmp_ret;
      }

      virtual void enabled_pos_set(Elm_Actionslider_Pos pos_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_actionslider_enabled_pos_set(pos_));
      }

      virtual ::efl::eina::string_view selected_label_get()
      {
         const char * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_actionslider_selected_label_get());
            return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
      }

   };
};


template<>
struct operation_description_class_size< ::elm::actionslider >
{
   static constexpr int value = 
#if defined(ACTIONSLIDER_PROTECTED) && defined(ACTIONSLIDER_BETA)
      7
#elif defined(ACTIONSLIDER_PROTECTED)
      7
#elif defined(ACTIONSLIDER_BETA)
      7
#else
      7
#endif
      + operation_description_class_size<::elm::layout >::value      + operation_description_class_size<::evas::selectable_interface >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::elm::actionslider>
                                 , Eo_Op_Description* ops)
{
   int i = 0;
   (void)i;
   (void)ops;
   ops[i].func = reinterpret_cast<void*>(& ::elm_actionslider_indicator_pos_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_actionslider_indicator_pos_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_actionslider_indicator_pos_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_actionslider_indicator_pos_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_actionslider_magnet_pos_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_actionslider_magnet_pos_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_actionslider_magnet_pos_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_actionslider_magnet_pos_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_actionslider_enabled_pos_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_actionslider_enabled_pos_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_actionslider_enabled_pos_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_actionslider_enabled_pos_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_actionslider_selected_label_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_actionslider_selected_label_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   initialize_operation_description<T>(::efl::eo::detail::tag<::elm::layout>(), &ops[operation_description_class_size< ::elm::actionslider >::value]);
   initialize_operation_description<T>(::efl::eo::detail::tag<::evas::selectable_interface>(), &ops[operation_description_class_size< ::elm::actionslider >::value + operation_description_class_size<::elm::layout>::value]);
   return 0;
}
inline Eo_Class const* get_eo_class(tag<::elm::actionslider>)
{
   return (ELM_ACTIONSLIDER_CLASS);
}

} } }

/// @endcond

